﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WeakReferance
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private MyButton mybutton = new MyButton();
        private Test root = new Test();

        public MainWindow()
        {
            InitializeComponent();
            Register();
        }

        private void Register()
        {
            mybutton.Click += root.TestRoot;
            mybutton.Click += mybutton_Click;
            mybutton.Click += new Test().TestNoRoot;
            
        }


        private static void mybutton_Click(object sender, EventArgs e)
        {
            MessageBox.Show("static method");
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            mybutton.FireClick();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            GC.Collect();
            MessageBox.Show("GC");
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            mybutton.Click -= mybutton_Click;
            mybutton.Click -= root.TestRoot;

            MessageBox.Show("Unregister");
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            Register();
            MessageBox.Show("Register");
        }



    }

    public class Test
    {
        public void TestNoRoot(object sender, EventArgs e)
        {
            MessageBox.Show("no root");
        }

        public void TestRoot(object sender, EventArgs e)
        {
            MessageBox.Show("root");
        }
    }




}
